import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import java.util.*;
import java.io.*;

class Gif2GP
{
	public static String hex(int n,int l)
	{
		String s = "000"+Integer.toHexString(n);
		return "0x"+s.substring(s.length()-l);
	}

	public static int gpcol(int c)
	{
		if ((c < 0xf8) && (c & 0x7) > 3)
			c += 8;
		return (c & 0xf8) >> 3;
	}

	public static int GPCOL(Color c)
	{
		return (gpcol(c.getRed()) << 11) + (gpcol(c.getGreen()) << 6) + (gpcol(c.getBlue()) << 1);
	}

	public static void main(String[] args) throws Exception
	{
		Image img = (new ImageIcon(args[0])).getImage();
		int w = img.getWidth(null);
		int h = img.getHeight(null);
		int[] pixels = new int[w * h];
		PixelGrabber pg = new PixelGrabber(img, 0, 0, w, h, pixels, 0, w);
		pg.grabPixels();

		PrintWriter pw = new PrintWriter(new FileOutputStream(args[1]));
		pw.println("#define "+args[2]+"_W "+w);
		pw.println("#define "+args[2]+"_H "+h);
		pw.println();

		int k = 0;
		pw.println("const u16 "+args[2]+"_IMG["+pixels.length+"] = {");
		for (int i=0;i<w;i++)
		{
			for (int j=0;j<h;j++)
			{
				int pix = GPCOL(new Color(pixels[(h-j-1)*w+i]));
				pw.print(hex(pix,4)+((++k)==pixels.length?"":","));
				if ((k%16)==0)
					pw.println();
			}
		}
		pw.println("};");
		pw.close();
	}
}
